package com.lc.utils;

import com.alibaba.druid.pool.DruidDataSourceFactory;

import javax.sql.DataSource;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.Properties;

/**
 * ClassName: DButils
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/28 10:27
 * @Version 1.0
 */
public class DButils {

    private static DataSource dataSource= null;

    //使用
    static {
        try {
            //Properties
            Properties properties = new Properties();
            // 数据源信息
            InputStream dataSourse = DButils.class.getClassLoader().getResourceAsStream("jdbc.properties");
            //加载配置文件配置文件
            properties.load(dataSourse);
            // 创建数据源
            dataSource = DruidDataSourceFactory.createDataSource(properties);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /*
       获取连接
     */
    public static Connection getConnection() throws SQLException {

        return dataSource.getConnection();
    }

    /*
   获取连接
 */
    public static DataSource getDataSource() throws SQLException {
        //单例
        return dataSource;
    }


}
