package com.lc.jdbc;

import org.junit.Test;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;

/**
 * ClassName: TestJdbc
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/25 10:27
 * @Version 1.0
 */
public class TestJdbc3 {

     @Test
     public void test01() throws Exception {
         //加载驱动
         Class.forName("com.mysql.cj.jdbc.Driver");
         //建立连接
         String user = "root";
         String pass = "123456";
         String url = "jdbc:mysql://127.0.0.1:3306/db2?useSSL=false";
         //连接
         Connection connection = DriverManager.getConnection(url, user, pass);
         // 事务
         connection.setAutoCommit(false);
         Statement statement = connection.createStatement();
         //案例
         // 悟空 给 卢俊义  转  1000.

         try {
             // 给悟空  - 1000
             String sql1 = " update emp set salary = salary - 1000 WHERE id = 1001; ";
             statement.execute(sql1);

             // 异常
             int i = 1 / 0;

             //  俊义   + 1000
             String sql2 = " update emp set salary = salary + 1000 WHERE id = 1002; ";
             statement.execute(sql2);

             //执行成功
             connection.commit();
             //转账成功
             System.out.println("转账成功");
         } catch (Exception e) {
             e.printStackTrace();
             //回滚
             connection.rollback();
             //转账失败
             System.out.println("转账失败");
         }
         //释放
         statement.close();
         connection.close();

     }
}
