package com.lc.jdbc;

import org.junit.Test;

import java.sql.*;
import java.util.Collections;

/**
 * ClassName: TestJdbc
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/25 10:27
 * @Version 1.0
 */
public class TestJdbc4 {

     @Test
     public void test01() throws Exception {
         //加载驱动
         Class.forName("com.mysql.cj.jdbc.Driver");
         //建立连接
         String user = "root";
         String pass = "123456";
         String url = "jdbc:mysql://127.0.0.1:3306/db2?useSSL=false";
         //连接
         Connection connection = DriverManager.getConnection(url, user, pass);

         //转账
         transfer("abc","1002",100,connection);

         //释放
         connection.close();

     }


     //转账方法
    public  boolean transfer(String fromId, String toId, int money , Connection conn) throws SQLException {
        // 事务
        conn.setAutoCommit(false);
        //改变 sql执行对象 PreparedStatement 变为字符串
        try {
            String sql1 = " update emp set salary = salary - ? WHERE id = ? ; ";
            //预编译
            PreparedStatement preparedStatement1 = conn.prepareStatement(sql1);
            //设置参数
            preparedStatement1.setInt(1,money);
            preparedStatement1.setString(2,fromId);
            //执行
            preparedStatement1.execute();
            //声明sql
            //参数 使用 ?
            String sql2 = " update emp set salary = salary + ? WHERE id = ? ; ";
            PreparedStatement preparedStatement2 = conn.prepareStatement(sql1);

            //设置参数  第一个参数是索引 从1开始 第几个?  第二个参数是值。
            //setXxx 类型
            preparedStatement2.setInt(1,money);
            preparedStatement2.setString(2,toId);
            //执行
            preparedStatement2.execute();
            //提交
            conn.commit();
            //转账成功
            System.out.println("转账成功");
            return true;
        } catch (SQLException ex) {
            ex.printStackTrace();
            //回滚
            conn.rollback();
            //转账失败
            System.out.println("转账失败");
            return false;
        }
    };
}
