package com.lc.jdbc1;

import java.sql.*;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * ClassName: EmpDao
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/25 15:54
 * @Version 1.0
 */
public class EmpDao {
    static Connection connection = null;
    static  {
        //建立连接
        String user = "root";
        String pass = "123456";
        String url = "jdbc:mysql://127.0.0.1:3306/db2?useSSL=false";
        //连接
        try {
            connection = DriverManager.getConnection(url, user, pass);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }


    public List<Emp> getAll() throws Exception{

        String sql = " select * from emp ";
        //预编译
        PreparedStatement statement = connection.prepareStatement(sql);

        ResultSet resultSet = statement.executeQuery();

        List<Emp> list = new ArrayList<>();
        while(resultSet.next()){
            Emp emp = new Emp();
            emp.setId(resultSet.getInt("id"));
            emp.setEname(resultSet.getString("ename"));
            emp.setJoindate(resultSet.getDate("joindate"));
            emp.setMgr(resultSet.getInt("mgr"));
            emp.setBonus(resultSet.getInt("bonus"));
            list.add(emp);
        }
        return list;
    }

    public Emp get(Integer id) throws Exception{

        String sql = " select * from emp where id = ? ";
        //预编译
        PreparedStatement statement = connection.prepareStatement(sql);
        //设置参数
        statement.setInt(1, id);

        ResultSet resultSet = statement.executeQuery();

        Emp emp = new Emp();
        while(resultSet.next()){
            emp.setId(resultSet.getInt("id"));
            emp.setEname(resultSet.getString("ename"));
            emp.setJoindate(resultSet.getDate("joindate"));
            emp.setMgr(resultSet.getInt("mgr"));
            emp.setBonus(resultSet.getInt("bonus"));
        }
        return emp;
    }



    public boolean del(Integer id) throws Exception{

        String sql = "  delete from emp where id = ? ";
        //预编译
        PreparedStatement statement = connection.prepareStatement(sql);
        //设置参数
        statement.setInt(1, id);

        //执行 返回的是受影响记录数
        return statement.executeUpdate() > 0;
    }


    public boolean add(Emp emp) throws Exception{

        String sql = " INSERT INTO `db2`.`emp` " +
                "( `ename`, `mgr`, `joindate`, `salary`, `bonus`,`id`) " +
                "VALUES (?,?,?,?,?,?); ";
        //预编译
        PreparedStatement statement = connection.prepareStatement(sql);
        //设置参数
        statement.setString(1, emp.getEname());
        statement.setInt(2, emp.getMgr());
        //sql时间
        Date date = new Date();
        statement.setDate(3, new java.sql.Date(date.getTime()));
        statement.setInt(4, emp.getSalary());
        statement.setInt(5, emp.getBonus());
        statement.setInt(6, emp.getId());

        return statement.execute();
    }

    public boolean update(Emp emp) throws Exception{

        String sql = " UPDATE `db2`.`emp` " +
                "SET `ename` = ?,  `mgr` = ?, `joindate` = ?, `salary` = ?, `bonus` = ?  WHERE `id` = ? ";
        //预编译
        PreparedStatement statement = connection.prepareStatement(sql);
        //设置参数
        statement.setString(1, emp.getEname());
        statement.setInt(2, emp.getMgr());
        //sql时间
        Date date = new Date();
        statement.setDate(3, new java.sql.Date(date.getTime()));
        statement.setInt(4, emp.getSalary());
        statement.setInt(5, emp.getBonus());
        statement.setInt(6, emp.getId());

        //执行 返回的是受影响记录数
        return statement.executeUpdate() > 0;
    }

}
