package com.lc.jdbc3;

import com.lc.utils.DButils;
import org.junit.Test;

import java.lang.reflect.Field;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/28 11:31
 * @Version 1.0
 */
public class Test01 {


    @Test
    public void test01() throws SQLException {
        //class
        Class<User> clazz = User.class;

        String sql = " select ";

        //判断是否有 Table
        boolean annotationPresent = clazz.isAnnotationPresent(Table.class);
        if (annotationPresent){

            //获取字段
            Field[] fields = clazz.getDeclaredFields();

            for (Field field : fields) {

                boolean anno = field.isAnnotationPresent(Column.class);

                if (anno){
                    //有注解
                    Column annotation = field.getAnnotation(Column.class);
                    String annoFiled = annotation.filed();

                    sql+= annoFiled + " , ";
                }else{
                    //没有注解
                    String filedName = field.getName();
                    sql+= filedName + " , ";
                }
            }
            sql+= " 1 ";

            sql+= " from ";

            //获取注解
            Table annotation = clazz.getAnnotation(Table.class);
            // 表名 value
            String tUser = annotation.value();

            sql += tUser + " ";
        }

        //执行 sql语句
        System.out.println(sql);

        //连接 DButils
        Connection connection = DButils.getConnection();

        PreparedStatement preparedStatement = connection.prepareStatement(sql);

        ResultSet resultSet = preparedStatement.executeQuery();

        while (resultSet.next()){
            System.out.println(resultSet.getString("name"));
        }

        connection.close();

    }

}
