package com.lc.day14.coll01;

import java.util.ArrayList;
import java.util.Collection;
import java.util.function.Predicate;

/**
 * ClassName: TestColl
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/10 10:12
 * @Version 1.0
 */
public class TestColl {

    /*
     * `public boolean add(E e)`：  把给定的对象添加到当前集合中 。
     * `public void clear()` :清空集合中所有的元素。
     * `public boolean remove(E e)`: 把给定的对象在当前集合中删除。
     * `public boolean contains(Object obj)`: 判断当前集合中是否包含给定的对象。
     * `public boolean isEmpty()`: 判断当前集合是否为空。
     * `public int size()`: 返回集合中元素的个数。
     * `public Object[] toArray()`: 把集合中的元素，存储到数组中
     * default boolean removeIf(Predicate<? super E> filter) 删除此集合中满足给定谓词的所有元素。
     */
    public static void main(String[] args) {
        //容器
        Collection coll = new ArrayList();

        coll.add(456);
        coll.add("123");
        coll.add(new Object()); // 4eec7777
        coll.add(new Double(1.0));
        coll.add("zs");

        System.out.println(coll);

        //clear
        //coll.clear();
        //System.out.println(coll);

        //remove
        boolean remove = coll.remove("zs");
        System.out.println(coll);

//        Object o = new Object();
//        System.out.println(o); //41629346
//        coll.remove(o);
//        System.out.println(coll); //

        //contains
        boolean contains = coll.contains(123);
        System.out.println(contains);

        //isEmpty
        boolean empty = coll.isEmpty();
        System.out.println(empty);

        //size
        System.out.println(coll.size());

        //toArray
        Object[] array = coll.toArray();

        for (int i = 0; i < array.length; i++) {
            System.out.println(array[i]);
        }

        //removeIf(Predicate<? super E> filter)
        //Predicate 判断
        //boolean test(T t); 返回true 删除 或者 false 不删除 传入实现规则


        coll.removeIf(new Predicate() {
            @Override
            public boolean test(Object object) {
                if (object.equals("123")){
                    return true;
                }
                return false;
            }
        });

        System.out.println(coll);
    }
}
