package com.lc.day16.coll06;

import java.sql.Connection;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

/**
 * ClassName: Test
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/12 11:45
 * @Version 1.0
 */
public class Test {
    public static void main(String[] args) {

        /*
        **排序操作：**
        - reverse(List)：反转 List 中元素的顺序
        - shuffle(List)：对 List 集合元素进行随机排序
        - sort(List)：根据元素的自然顺序对指定 List 集合元素按升序排序
        - sort(List，Comparator)：根据指定的 Comparator 产生的顺序对 List 集合元素进行排序
        - swap(List，int， int)：将指定 list 集合中的 i 处元素和 j 处元素进行交换
         */

        List<Integer> integers = List.of(4, 2, 324, 234, 25, 34, 65, 367);

        ArrayList<Integer> list = new ArrayList<>(integers);
        //反转
        Collections.reverse(list);

        System.out.println(list);

        //shuffle 随机调换  洗牌
        Collections.shuffle(list);
        System.out.println(list);

        //sort
        Collections.sort(list);
        System.out.println(list);

        //Comparator
        Collections.sort(list, new Comparator<Integer>() {
            @Override
            public int compare(Integer o1, Integer o2) {
                return Integer.compare(o2, o1);
            }
        });

        System.out.println(list);


        //交换
        Collections.swap(list, 0, list.size() - 1);

        System.out.println(list);
    }
}
