package com.lc.day18.file05;

import java.io.File;
import java.io.FileFilter;

/**
 * ClassName: Test
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/16 15:20
 * @Version 1.0
 */
public class Test {

    /*
    | 方法                                           | 描述                                                         |
    | ---------------------------------------------- | ------------------------------------------------------------ |
    | public File getParentFile()                    | 返回此抽象路径名父目录的抽象路径名                           |
    | public File[] listFiles()                      | 返回一个File数组，所有的子文件或目录。                       |
    | public File[] listFiles(FileFilter filter)     | 返回所有满足指定过滤器的文件和目录。<br>如果给定 filter 为 null，则接受所有路径名。 |
    | public File[] listFiles(FilenameFilter filter) | 路径名满足过滤器返回true。                                   |
     */
    public static void main(String[] args) {
        File file = new File("day18\\src\\com\\lc\\day18\\file04");

        //获取父类文件
        String parent = file.getParent();
        System.out.println(parent);

        File parentFile = file.getParentFile();
        System.out.println(parentFile);

        //子文件
        String[] list = file.list();
        for (int i = 0; i < list.length; i++) {
            System.out.println(list[i]);
        }

        File[] files = file.listFiles();

        for (File file1 : files) {
            System.out.println(file1);
        }

        //listFiles
        File[] files1 = file.listFiles(new FileFilter() {
            @Override
            public boolean accept(File pathname) {
                String name = pathname.getName();

                if (name.contains("1")) {
                    return false;
                }
                return true;
            }
        });

        for (File file1 : files1) {
            System.out.println(file1);
        }
    }
}
