package com.lc.day18.thread03;

import java.util.concurrent.*;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/16 11:48
 * @Version 1.0
 */
public class Test01 {

    public static void main(String[] args) throws ExecutionException, InterruptedException {

        ExecutorService service = Executors.newFixedThreadPool(5);

        service.execute(new Runnable() {
            @Override
            public void run() {
                System.out.println("执行了");
            }
        });

        FutureTask<Integer> integerFutureTask = new FutureTask<>(new Callable<Integer>() {
            @Override
            public Integer call() throws Exception {
                int sum = 0;
                for (int i = 0; i < 100; i += 2) {
                    sum += i;
                }
                return sum;
            }
        });
        //callable
        service.submit(integerFutureTask);

        //获取结果

        Integer i = integerFutureTask.get();
        System.out.println(i);

    }
}
