package com.lc.day20.recf03;

import org.junit.Test;

import java.lang.reflect.*;
import java.util.Arrays;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/18 13:39
 * @Version 1.0
 */
public class Test01 {

    @Test
    public void test01() throws Exception {

        Class<Person> clazz = Person.class;

        //class api
        String name = clazz.getName();
        System.out.println("类名："+name);

        //Constructor api
        Constructor<Person> constructorName = clazz.getConstructor(String.class);

        //修饰符
        int modifiers = constructorName.getModifiers();
        System.out.println(Modifier.toString(modifiers));

        Person kunkun = constructorName.newInstance("坤坤");
        System.out.println(kunkun);


        //获取所有的构造
        Constructor<?>[] constructors = clazz.getConstructors();

        for (Constructor<?> constructor : constructors) {
            System.out.println(constructor);
        }

        System.out.println("------------");


        //属性 字段
        //Field nameFiled = clazz.getField("name"); //获取私有的
        Field nameFiled = clazz.getDeclaredField("name");
        //暴力破解
        nameFiled.setAccessible(true);
        //获取
        Object o = nameFiled.get(kunkun);
        //值
        System.out.println(o);


        Field[] declaredFields = clazz.getDeclaredFields();

        for (Field declaredField : declaredFields) {
            System.out.println(declaredField);
        }

        System.out.println("------------");
        Method compareTo = clazz.getDeclaredMethod("compareTo", Person.class);

        System.out.println(compareTo);

        Object num = compareTo.invoke(kunkun, new Person("凡凡"));
        System.out.println(num);

        //获取所有的方法
        Method[] declaredMethods = clazz.getDeclaredMethods();

        for (Method method : declaredMethods) {
            System.out.println(method);
        }

        System.out.println("------------");
        //父类
        Class<? super Person> superclass = clazz.getSuperclass();
        System.out.println(superclass);

        //接口
        Class<?>[] interfaces = clazz.getInterfaces();

        for (Class<?> anInterface : interfaces) {
            System.out.println(anInterface);

        }

        Type[] genericInterfaces = clazz.getGenericInterfaces();
        for (Type genericInterface : genericInterfaces) {
            Type t = ((ParameterizedType) genericInterface).getActualTypeArguments()[0];
            System.out.println(t.getTypeName());
            //泛型
            Class<?> aClass = Class.forName(t.getTypeName());

            //System.out.println(Arrays.toString(aClass.getDeclaredFields()));

        }

        //反射创建数组
        String[] o1 = (String[]) Array.newInstance(String.class, 10);

        o1[0] = "坤坤";

        //反射
        Array.set(o1,1, "凡凡");
        System.out.println(Arrays.toString(o1));


    }

}
