package com.lc.day21.stream04;

import org.junit.Test;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/19 13:47
 * @Version 1.0
 */
public class Test01 {

    @Test
    public void test01(){
        /*
        Java8 中的 Collection 接口被扩展，提供了两个获取流的方法：

        * public default Stream<E> stream() : 返回一个顺序流
        * public default Stream<E> parallelStream() : 返回一个并行流
         */


        List<Integer> integers = List.of(123, 1, 2, 423, 435, 34, 64, 57, 564, 785, 678, 67);
        ArrayList<Integer> list = new ArrayList<>(integers);

        Stream<Integer> stream = list.stream();
        //操作
        Stream<Integer> integerStream = stream.filter(e -> e > 100);

        //终止
        List<Integer> collect = integerStream.collect(Collectors.toList());

        System.out.println(collect);

        //循环


        //链式操作
        list.stream().filter( e -> e % 2 == 0).forEach(System.out::println);


    }

    @Test
    public void test02(){
        List<Integer> integers = List.of(123, 1, 2, 423, 435, 34, 64, 57, 564, 785, 678, 67);
        ArrayList<Integer> list = new ArrayList<>(integers);

        //并行流
        Stream<Integer> integerStream = list.parallelStream();

        integerStream.filter(e -> e > 100).forEach(System.out::println);
    }


}
