package com.lc.day21.stream04;


import org.junit.Test;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Stream;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/19 13:47
 * @Version 1.0
 */
public class Test03 {

    @Test
    public void test01(){
        List<Employee> employees = new ArrayList<>();
        employees.add(new Employee(1,"zs",20000.0,20,"男"));
        employees.add(new Employee(2,"ls",1400.0,23,"女"));
        employees.add(new Employee(3,"ww",2000.0,21,"男"));
        employees.add(new Employee(4,"zl",8000.0,32,"女"));
        employees.add(new Employee(5,"c7",18900.0,27,"男"));
        employees.add(new Employee(6,"w8",2200.0,20,"女"));
        employees.add(new Employee(6,"w8",2200.0,20,"女"));


        //Stream filter(Predicate p)接收 Lambda ， 从流中排除某些元素
        //Stream distinct()筛选，通过流所生成元素的equals() 去除重复元素
        //Stream limit(long maxSize)截断流，使其元素不超过给定数量
        //Stream skip(long n)跳过元素，返回一个扔掉了前 n 个元素的流。若流中元素不足 n 个，则返回一个空流。与 limit(n) 互补
        //Stream peek(Consumer action)接收Lambda，对流中的每个数据执行Lambda体操作
        //Stream sorted()产生一个新流，其中按自然顺序排序
        //Stream map(Function f)接收一个函数作为参数，该函数会被应用到每个元素上，并将其映射成一个新的元素。
        employees.stream()
                .filter( e->e.getSalary() > 2000)
                .distinct()
                //.limit(3)
                //.skip(2)
                //.peek( e -> e.setSalary(e.getSalary() * 1.1))
                .sorted( (e1,e2) -> Double.compare(e1.getSalary(),e2.getSalary()))
                //.map( e -> e.getName() )
                .mapToInt( e -> e.getAge() )
                .forEach(System.out::println);

    }

    @Test
    public void test02(){

        //把所有单词的每一个字母取出来
        Stream.of("hello","java","c++","python","php")
                .flatMap( s -> Arrays.stream(s.split("|"))  )
                .forEach(System.out::println);
    }

}
