package com.lc.day21.stream04;


import org.junit.Test;

import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/19 13:47
 * @Version 1.0
 */
public class Test04 {

    /*
    boolean**allMatch(Predicate p)**检查是否匹配所有元素
    boolean**anyMatch**(**Predicate p**)检查是否至少匹配一个元素
    boolean**noneMatch(Predicate  p)**检查是否没有匹配所有元素
     */
    @Test
    public void test01(){
        boolean b = Stream.of(2, 4, 6, 8)
                //.allMatch(n -> n % 2 == 0);
                //.anyMatch(n -> n == 2 );
                .noneMatch(n -> n== 10);
        System.out.println(b);

    }

    /*
    Optional<T>**findFirst()**返回第一个元素
    Optional<T>**findAny()**返回当前流中的任意元素
     */
    @Test
    public void test02(){
        //Optional解决空指针
//        Optional<Integer> first = Stream.of(2, 4, 6, 8)
//                .findFirst();

        for (int i = 0; i < 1000; ) {
            Optional<Integer> any = Stream.of(2, 4, 6, 8)
                    .findAny();
            //System.out.println(any);
            if (any.get() != 2){
                break;
            }
        }
//        Optional<Integer> any = Stream.of(2, 4, 6, 8)
//                .findAny();
//
//        System.out.println(any);
    }

    /*
    long**count()**返回流中元素总数
     */
    @Test
    public void test03(){
        long count = Stream.of(2, 4, 6, 8).count();
        System.out.println(count);
    }

    /*
    T**reduce(T iden, BinaryOperator b)**将流中元素反复结合起来，得到一个值。返回 T
     */
    @Test
    public void test04(){
        Integer reduce = Stream.of(2, 4, 6, 8).reduce(0, (n1, n2) -> n1 + n2);
        System.out.println(reduce);
    }


    //**collect

    @Test
    public void test05(){
        Map<Integer, String> collect = Stream.of(1, 2, 3, 4, 5, 6)
                .collect(Collectors.toMap(i -> i, i -> "第" + i + "个元素"));

        System.out.println(collect);
    }


}
