package com.lc.day21.stream05;

import org.junit.Test;

import java.util.Comparator;
import java.util.function.Consumer;
import java.util.stream.Stream;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/19 16:05
 * @Version 1.0
 */
public class Test01 {
    @Test
    public void test01(){
        //实例对象名::实例方法
        //针对情况1：函数式接口中的抽象方法a在被重写时使用了某一个对象的方法b。如果方法a的形参列表、
        // 返回值类型与方法b的形参列表、返回值类型都相同，则我们可以使用方法b实现对方法a的重写、替换。

        //之前
        Consumer<Integer> consumer = e -> System.out.println(e);

        //抽象方法a  void accept(T t);
        //方法b  是 a 的实现方法

        /* 方法b
        public void println(Object x) {
            。。。。。
        }
        */

        //方法引用
        Consumer<Integer> consumer1 = System.out::println;
    }

    @Test
    public void test02(){

        /*
        针对情况2：函数式接口中的抽象方法a在被重写时使用了某一个类的静态方法b。如果方法a的形参列表、
        返回值类型与方法b的形参列表、返回值类型都相同，则我们可以使用方法b实现对方法a的重写、替换。
         */

        //Stream<Double> stream = Stream.generate(Math::random);

        // 方法a   T get();
        // 方法b   public static double random() {
        Stream<Double> generate = Stream.generate(Math::random);
    }


    public void test03(){

        /*
        针对情况3：函数式接口中的抽象方法a在被重写时使用了某一个对象的方法b。
        如果方法a的返回值类型与方法b的返回值类型相同，同时方法a的形参列表中有n个参数，
        方法b的形参列表有n-1个参数，
        且方法a的第1个参数作为方法b的调用者， a 调用 方法b
        且方法a的后n-1参数与方法b的n-1参数匹配（类型相同或满足多态场景也可以）
         */

        //抽象方法a  int compare(T o1, T o2);
        //实现方法  方法 b  public int compareTo(Integer anotherInteger) {

        //lambda
        Comparator<Integer> comparable = (s1,s2) -> s1.compareTo(s2);

        //类名称： 方法
        Comparator<Integer> comparable1 = Integer::compareTo;


    }
}
