package com.lc.mybatis01.test;

import com.lc.mybatis01.mapper.UserMapper;
import com.lc.mybatis01.pojo.User;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/29 9:36
 * @Version 1.0
 */
public class Test01 {

    @Test
    public void test01() throws IOException {
        //数据源在xml中 mybatis-config.xml 核心配置文件。
        // mybatis-config.xml
        // UserMapper.xml

        //获取sqlseesionfactory
        InputStream is = Resources.getResourceAsStream("mybatis-config.xml");

        SqlSessionFactory sqlSessionFactory = new SqlSessionFactoryBuilder().build(is);
        //获取sqlSession
        SqlSession sqlSession = sqlSessionFactory.openSession();
        //执行sql  select 标签位置 namespace + 标签id
        //User user = sqlSession.selectOne("mapper.UserMapper.selectUser", 2);


        //UserMapper 代理对象
        UserMapper mapper = sqlSession.getMapper(UserMapper.class);

        //获取 namespace + 标签id
        List<User> userList = mapper.getUserList();

        userList.forEach(System.out::println);
    }


    @Test
    public void test02() throws Exception{
        //获取sqlseesionfactory
        InputStream is = Resources.getResourceAsStream("mybatis-config.xml");

        SqlSessionFactory sqlSessionFactory = new SqlSessionFactoryBuilder().build(is);
        //获取sqlSession
        SqlSession sqlSession = sqlSessionFactory.openSession();

        //UserMapper 代理对象
        UserMapper mapper = sqlSession.getMapper(UserMapper.class);

        //获取 namespace + 标签id
        List<User> userList = mapper.getUserList();

        userList.forEach(System.out::println);
    }
}