package com.lc.mybatis01.test;

import com.lc.mybatis01.mapper.UserMapper;
import com.lc.mybatis01.pojo.User;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/29 9:36
 * @Version 1.0
 */
public class Test02 {

    SqlSession sqlSession = null;

    @Before
    public void before() throws Exception{
        //获取sqlseesionfactory
        InputStream is = Resources.getResourceAsStream("mybatis-config.xml");

        SqlSessionFactory sqlSessionFactory = new SqlSessionFactoryBuilder().build(is);

        //获取sqlSession
        sqlSession = sqlSessionFactory.openSession(true);
    }

    @Test
    public void test01() throws Exception{

        UserMapper mapper = sqlSession.getMapper(UserMapper.class);
        User user = new User();
        user.setId(3);
        user.setName("韩梅梅");
        user.setAge(22);
        user.setAddress("上海");
        user.setLoginName("hmm");

        int i = mapper.addUser(user);

        System.out.println(i);
    }


    @Test
    public void test03() throws Exception{

        UserMapper mapper = sqlSession.getMapper(UserMapper.class);

        User user = new User();
        user.setName("李明");
        user.setAge(23);
        user.setAddress("北京");
        user.setLoginName("lm");

        int i = mapper.addUserKey(user);

        System.out.println(user);

    }


    @Test
    public void test04() throws Exception{

        UserMapper mapper = sqlSession.getMapper(UserMapper.class);

        User user = new User();
        user.setId(8);
        user.setName("李明8号");
        user.setAge(23);
        user.setAddress("北京");
        user.setLoginName("lm");

        int i = mapper.updateUser(user);
        System.out.println(user);

    }


    @Test
    public void test05() throws Exception{

        UserMapper mapper = sqlSession.getMapper(UserMapper.class);

        int i = mapper.deleteById(8);
        System.out.println(i);

    }

    @Test
    public void test06() throws Exception{

        UserMapper mapper = sqlSession.getMapper(UserMapper.class);

        User userById = mapper.getUserById(7);
        System.out.println(userById);

    }

}