package com.lc.mybatis02.test;


import com.lc.mybatis02.pojo.User;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.Before;
import org.junit.Test;
import com.lc.mybatis02.mapper.UserMapper;

import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/29 9:36
 * @Version 1.0
 */
public class Test01 {

    SqlSession sqlSession = null;

    @Before
    public void before() throws Exception{
        //获取sqlseesionfactory
        InputStream is = Resources.getResourceAsStream("mybatis-config2.xml");

        SqlSessionFactory sqlSessionFactory = new SqlSessionFactoryBuilder().build(is);

        //获取sqlSession
        sqlSession = sqlSessionFactory.openSession(true);
    }

    @Test
    public void test01() throws Exception{
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        List<User> list = userMapper.getUserByNameAndAge("张三", 20);

        System.out.println(list);
    }

    @Test
    public void test02() throws Exception{
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        Map<String,Object> map = new HashMap<>();
        map.put("name","张三");
        map.put("age",20);

        List<User> list = userMapper.getUserByNameAndAge2Map(map);

        System.out.println(list);
    }


    @Test
    public void test03() throws Exception{

        UserMapper mapper = sqlSession.getMapper(UserMapper.class);
        User user = new User();
        user.setId(13);
        user.setName("小黑");
        user.setAge(22);
        user.setAddress("上海");
        user.setLoginName("xh");

        int i = mapper.addUser(user);

        System.out.println(i);
    }

    @Test
    public void test04() throws Exception{

        UserMapper mapper = sqlSession.getMapper(UserMapper.class);

        int i = mapper.deleteById(13);
        System.out.println(i);

    }

    @Test
    public void test05() throws Exception{
        UserMapper mapper = sqlSession.getMapper(UserMapper.class);
        //#{name} 使用的预编译的sql执行对象
        //List<User> list = mapper.getUserByName1("张三");
        List<User> list = mapper.getUserByName1("'张三' or 1=1 ");
        System.out.println(list);
    }

    @Test
    public void test06() throws Exception{
        UserMapper mapper = sqlSession.getMapper(UserMapper.class);
        //${name}  原生参数。
        //List<User> list = mapper.getUserByName2("'张三'");
        List<User> list = mapper.getUserByName2("'张三' or 1=1 ");
        System.out.println(list);
    }
}