package com.lc.mybatis02.test;


import com.lc.mybatis02.mapper.DeptMapper;
import com.lc.mybatis02.mapper.UserMapper;
import com.lc.mybatis02.pojo.Dept;
import com.lc.mybatis02.pojo.User;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.Before;
import org.junit.Test;

import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/29 9:36
 * @Version 1.0
 */
public class Test02 {

    SqlSession sqlSession = null;

    @Before
    public void before() throws Exception{
        //获取sqlseesionfactory
        InputStream is = Resources.getResourceAsStream("mybatis-config2.xml");

        SqlSessionFactory sqlSessionFactory = new SqlSessionFactoryBuilder().build(is);

        //获取sqlSession
        sqlSession = sqlSessionFactory.openSession(true);
    }

    @Test
    public void test01() throws Exception{
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        User user = userMapper.getUserById(1);

        System.out.println(user);
    }

    @Test
    public void test02() throws Exception{
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        List<User> users = userMapper.getUsers();

        System.out.println(users);
    }

    @Test
    public void test03() throws Exception{
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        User user = userMapper.getUserById2(1);

        System.out.println(user);
    }


    @Test
    public void test04() throws Exception{
        DeptMapper deptMapper = sqlSession.getMapper(DeptMapper.class);

        List<Dept> list = deptMapper.getDeptById(1);

        list.forEach(System.out::println);
    }


    //getUserByIdAssociation
    @Test
    public void test05(){
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        User user = userMapper.getUserByIdAssociation(1);

        System.out.println(user);
    }


    //getDeptById2Collection
    @Test
    public void test06() throws Exception{
        DeptMapper deptMapper = sqlSession.getMapper(DeptMapper.class);

        Dept deptById2Collection = deptMapper.getDeptById2Collection(1);

        System.out.println(deptById2Collection);
    }


    //getUserByIdAssociationStep
    @Test
    public void test07(){
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        User user = userMapper.getUserByIdAssociationStep(1);

        System.out.println(user);
    }


    //延迟加载
    @Test
    public void test08(){
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        User user = userMapper.getUserByIdAssociationStep(1);

        String name = user.getName();
        System.out.println(name);
        System.out.println("++++++++++++++++++++");
        //没有使用到部门的属性
        System.out.println(user.getDept());

    }

}