package com.lc.mybatis03.test;


import com.lc.mybatis03.mapper.UserMapper;
import com.lc.mybatis03.pojo.User;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.Before;
import org.junit.Test;

import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/29 9:36
 * @Version 1.0
 */
public class Test01 {

    SqlSession sqlSession = null;

    @Before
    public void before() throws Exception{
        //获取sqlseesionfactory
        InputStream is = Resources.getResourceAsStream("mybatis-config3.xml");
        SqlSessionFactory sqlSessionFactory = new SqlSessionFactoryBuilder().build(is);
        //获取sqlSession
        sqlSession = sqlSessionFactory.openSession(true);
    }

    @Test
    public void test01() throws Exception{
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        User user = new User();
        //user.setName("zs");
        //user.setLoginName("zs");
        user.setAddress("上海");

        List<User> list = userMapper.getUserByCondition(user);
        list.forEach(System.out::println);
    }



    //updateUserByCondition
    @Test
    public void test02() throws Exception{
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        User user = new User();
        user.setName("zs");
        user.setLoginName("zs");
        //user.setAddress("上海");
        user.setId(10);

        int i = userMapper.updateUserByCondition(user);
        System.out.println(i);
    }

    //updateUserByConditionTrim
    @Test
    public void test03() throws Exception{
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        User user = new User();
        user.setName("zs");
        user.setLoginName("zs");
        //user.setAddress("上海");
        user.setId(10);

        int i = userMapper.updateUserByConditionTrim(user);
        System.out.println(i);
    }


    @Test
    public void test04() throws Exception{
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);
        List<User> list = userMapper.getUserByIds(List.of(1, 2, 3));

        System.out.println(list);
    }
}