package com.lc.mybatis03.test;


import com.lc.mybatis03.mapper.UserMapper;
import com.lc.mybatis03.pojo.User;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/29 9:36
 * @Version 1.0
 */
public class Test02 {

    SqlSession sqlSession = null;

    @Before
    public void before() throws Exception{
        //获取sqlseesionfactory
        InputStream is = Resources.getResourceAsStream("mybatis-config3.xml");
        SqlSessionFactory sqlSessionFactory = new SqlSessionFactoryBuilder().build(is);
        //获取sqlSession
        sqlSession = sqlSessionFactory.openSession(true);
    }

    @Test
    public void test01() throws Exception{
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);

        User user1 = userMapper.getUserById(7);
        System.out.println(user1);
//        System.out.println("--------------");
//
//        User user = new User();
//        user.setName("zs");
//        user.setLoginName("zs");
//        //user.setAddress("上海");
//        user.setId(10);
//
//        int i = userMapper.updateUserByConditionTrim(user);
//        System.out.println(i);
        //手动提交  一级缓存失效
        sqlSession.commit();
        //手动清空  一级缓存失效
        sqlSession.clearCache();

        System.out.println("--------------");

        // 是否发送sql语句;
        User user2 = userMapper.getUserById(7);
        System.out.println(user2);

        //默认使用一级缓存。
    }

    //二级缓存 手动开启
    @Test
    public void test02() throws IOException {

        //获取sqlseesionfactory
        InputStream is = Resources.getResourceAsStream("mybatis-config3.xml");
        SqlSessionFactory sqlSessionFactory = new SqlSessionFactoryBuilder().build(is);
        //获取sqlSession
        SqlSession sqlSession1 = sqlSessionFactory.openSession(true);
        SqlSession sqlSession2 = sqlSessionFactory.openSession(true);

        //从sqlSession1 执行查询。
        UserMapper mapper1 = sqlSession1.getMapper(UserMapper.class);
        User user1 = mapper1.getUserById(1);

        System.out.println(user1);
        //手动提交
        sqlSession1.commit();

        UserMapper mapper2 = sqlSession2.getMapper(UserMapper.class);

        User user2 = mapper2.getUserById(1);
        User user3 = mapper2.getUserById(1);
        User user4 = mapper2.getUserById(1);
        User user5 = mapper2.getUserById(1);

        sqlSession2.commit();

    }
}